<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


 /**
  * Class for create html dropdown fields
  *
  * @since 2011-08
  */

class Drop_Down extends Dbc
{
    protected $condition = 1; // Condition in the sql query while getting the values
    protected $table; // table
    protected $arr_data = array(); // Aray with data for the dropdown list
    protected $arr_fields = array(); // fields for the list
    protected $field_name; // name of the drop down field
    protected $field_name_source = 'id'; // name of the source field, default "id"
    protected $selected_field; // the selected field of the list
    private $drop_down_inaktiv = '';

    
/**
 * Set values for drop down
 * 
 * @param type $value 
 */
function set_values_db($table, $field_name, $arr_fields, $selected_field='')
{
    $this->table = $table;
    $this->arr_fields = $arr_fields;
    $this->field_name = $field_name;
    $this->selected_field = $selected_field;
    $this->make_array_for_drop_down();
}
    
/**
 * 
 * @param type $value 
 */

/**
 * Set values for drop down
 *
 * @param type $field_name
 * @param array $arr_data Assoc array $key => $value
 *  $key is displayed, $value is value of the option
 * @param type $selected_field 
 */
function set_values_array($field_name, $arr_data, $selected_field='')
{
    $this->field_name = $field_name;
    $this->arr_data = $arr_data;
    $this->selected_field = $selected_field;
}
    

/**
 * Set values for drop down
 *
 * @param type $sql_condition 
 */
function set_condition($sql_condition)
{
    $this->condition = $sql_condition;
    if (empty($sql_condition)) {
        $this->condition = 1;
        
    }
}


function set_field_name_source($field_name_source)
{
    $this->field_name_source = $field_name_source;
}
  
/**
 * Set, if drop_down is active or not
 *
 * @param int $bool  0=inactive, 1=active
 */
function set_drop_down_inactive($bool) 
{
    if ($bool == 1) {
        $this->drop_down_inaktiv = ' disabled ';
    }elseif($bool == 0) {
        $this->drop_down_inaktiv = '';
    }
}
    
    
/**
 * Get array for dropdown
 * Name of primary must be "id"
 * 
 */
function make_array_for_drop_down()
{
    global $la_nothing_selected;
    
    $arr = array();
    $arr[0] = 'Nichts gewhlt';
    $fields = implode(',', $this->arr_fields);
    $query = "SELECT $this->field_name_source, $fields FROM $this->table WHERE $this->condition ";
    $result = $this->query($query);

    while($row = $this->fetch_array($result)) {
        // initial $value
        $value = '';

        // Loop the fields
        for($i=0; $i < count($this->arr_fields); $i++) {
            // if field is like 'decimal_places' ()
            if ($this->arr_fields[$i] == 'decimal_places') {
                $places = '  0,';
                // iterate value of 'decimal_places' to show 0,0 or 0,00 or 0,000
                for($j=0; $j<=$row[$this->arr_fields[$i]]; $j++) {
                    // Add a zerro
                    $places .= '0';
                }
                $value .= $places;
                
            }else{
                $value .= $row[$this->arr_fields[$i]] . ', ';
            }
        }
        $value = substr($value, 0, -1);
        $arr[$row[0]] = $value;
    }
    
    $this->db_error_handler();
    $this->arr_data = $arr;
}

    

/**
 *
 * @param type $label
 * @param type $width 
 */
function make_drop_down($label=1, $width='' )
{
    if (empty($this->arr_data)) {
        return false;
    }
    // Create width or not
    if (empty($width)) {
        $show_width = '';
    }else{
        $show_width = ' style="width:' . $width. 'px" ';
    }
    $drop = '';
    $drop .= "\n" . '<select ' . $this->drop_down_inaktiv . $show_width  
          . ' name="' . $this->field_name . '">';
    foreach ($this->arr_data as $key => $value) {
        // Preselection of list
        if( $key == $this->selected_field) {
            $selected = "selected ";
        }else{
            $selected = '';
        }

        $drop .= "\n<option "  . $selected . 'value="' . $key . '"> ' . $value;
        $drop .= '</option>';
    }
    $drop .= '</select> ';
    if(!empty($label)) {
        if ($label == 1) {
            $drop .= $GLOBALS['la_'.$this->field_name];
        }else{
            $drop .= $label;
        }
    }
    
    return $drop;
}


} // end class