<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


 /**
  * Class for creating and displaying links with query-string
  * 
  *
  * Requires: none
  * 
  * @since 2010-12
  */
class Link
{
    public  $target = 1; // 1 = self, 2 = blank
    public  $condition = 1;
    public  $class_name; // css klasse
    public  $class_or_style = 'class';
    public  $inactive;
    protected  $list = true;


    /**
     * Makes a '<a href=...' link to $ziel
     * 
     * 11-07-17 change "&" to "$amp;"
     * 
     * @param type $target
     * @param type $inscription
     * @param type $query_str_arr
     * @param type $title
     * @return string 
     */
    function make_link($target, $inscription, $query_str_arr='', $title="link")
    {
        if ($this->condition) {
            $link = '';
            
            // Check if "?" exists in target
            $query_string_in_target = stristr($target, '?');
            
            
            if ($this->list == true) {
                $link .= '<li>';
            }
            
            if ($this->target == 2) {
                $blank = ' target="blank" ';
            }else{
                $blank = '';
            }
            
            /**
             *  array treatment
             */
            if (is_array($query_str_arr)) {
                if (!empty ($query_str_arr)) {
                    // If target contains "?"
                    if ($query_string_in_target) {
                        $str_get = '&amp;';
                    }  else {
                        $str_get = '?';
                    }
                }else{
                    $str_get = '';
                }

                // '&amp;' is save for all browsers, '&' don't works constantly
                foreach($query_str_arr as $feld => $wert ) {
                    $str_get .= $feld . '=' . $wert . '&amp;';
                }
                // Remove last ampersand &amp;
                $str_get = substr($str_get, 0, -5);

            /**
             *  string treatment
             */
            }  elseif (is_string($query_str_arr)) {
                if (!empty ($query_str_arr)) {
                    // If target contains "?"
                    if ($query_string_in_target) {
                        $str_get = '&amp;' . $query_str_arr;
                    }  else {
                        $str_get = '?' . $query_str_arr;
                    }
                }else{
                    $str_get = '';
                }
            }  else {
                $str_get = '';
            }

            // inactive or not
            if ($this->inactive == 1) {
                $a_or_span = 'span';
                $this->class_name = 'inactive';
            }else{
                $a_or_span = 'a';
            }
            
            // css-class
            if ($this->class_name == '') {
                $cl = '';
            }else{
                $cl = $this->class_or_style . '="' . $this->class_name . '"';
            }

            //$la_get = urlencode($la_get);

            $link .= '<' . $a_or_span . ' ' . $cl . ' href="' 
                  . $target . $str_get . '"' . ' title="' . $title . '"' . $blank . '>' 
                  . $inscription . '</' . $a_or_span . '>';
            
            if ($this->list == true) {
                $link .= '</li>';
            }
            return $link;
        } // end condition
    }



    /**
     * Makes the link inactive and gray
     * 
     * @param boolean $bool 
     */
    public function inactive($bool=1) 
    {
        $this->inactive = $bool;
    }


    /**
     * set css class for the link
     * 
     * @param <type> $class_name
     */
    public function set_class($class_name='') 
    {
        $this->class_name = $class_name;
    }

    /**
     * set condition when the link will be displayed
     * 
     * @param string $condition
     */
    public function set_condition($condition) 
    {
        $this->condition = $condition;
    }

    /**
     * set class or style for the link
     * param must be 'style'. 'class' is default
     * 
     * @param <type> $param
     */
    public function set_class_or_style($param) 
    {
        $this->class_or_style = $param;
    }
    
    

    /**
     * Shows html tags <li> LINK </li>
     * @param bool $true 
     */
    public function set_list($bool) 
    {
        $this->list = $bool;
    }

    /**
     * Shows html tags <li> LINK </li>
     * @param integer $target 1=self, 2=blank
     */
    public function set_target($target=2) 
    {
        $this->target = $target;
    }

} // end class