<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


 /**
  * Class for creating and displaying links with query-string
  *
  * Required: class Link()
  * 
  * @since      2012-01
  */
class Link_Menu extends Link
{
    // affected tabel
    protected $condition_background;
    protected $condition_background_default;
    protected $get_key = 'tbl';
    protected $tbl;
    

/**
 * Makes links for the main menu. After pressing with coloured background
 * Sets the background for the link
 * 
 * @param type $tbl
 */
function set_background($tbl) 
{
    global $invert;
    
    $this->tbl = $tbl;
    
    $this->set_condition_background_default($tbl);
    
    if (empty($this->condition_background)) {
        $condition = $this->condition_background_default;
    }else{
        $condition = $this->condition_background;
    }
    
    if ($tbl == 'ord') {
        $condition = ( $this->condition_background_default )
        and (!isset($_SESSION['todo']) and !isset($_REQUEST['todo']));
    }else{
        $condition = $this->condition_background_default;
    }
    
    
    if ($condition) {
        $fat = $invert;
    }else{
        $fat = '';
    }
    $this->set_class($fat);
    return $fat;
}


/**
 * set condition for the colour of the background
 * 
 * @param string $condition
 */
function set_condition_background($condition) 
{
    $this->condition_background = $condition;
}


function set_get_key($name_of_key) 
{
    $this->get_key = $name_of_key;
}


/**
 * set condition for the colour of the background
 * 
 * @param string $tbl
 */
function set_condition_background_default($tbl) 
{
    $condition_base =   (isset($_REQUEST[$this->get_key]) and $_REQUEST[$this->get_key] == $tbl) 
                    or  (isset($_SESSION[$this->get_key]) and  $_SESSION[$this->get_key] == $tbl);
    $this->condition_background_default = $condition_base;
}


/**
 *
 * @param type $tbl
 * @param type $inscription
 * @param type $arr
 * @param type $title
 * @param type $target
 * @return type 
 */
function set_link($tbl, $inscription, $arr, $title='', $target='query.php') 
{
    global $arr;
    
    $arr[$this->get_key] = $tbl;
    $this->set_background($tbl);
    return $this->make_link(PROJECT_HTTP_ROOT.$target, $inscription, $arr, $title);
}


/**
 * Includes modules and working togehter with values in tbl_0_user
 * f.i. mod_analysis, mod_email etc. and the exist of files
 * f.i. /modul/analysis/analysis.php, /modul/email/emai.php etc.
 * 
 * @global  $use
 * @param str $modul Name of modul
 * @param str $target File with path
 * @param <type> $inscription link text
 * @param str/arr $query_str_arr Parameters for link
 */
function insert_modul($modul, $target, $inscription, $query_str_arr) 
{
    global $use;
    
    $file = PROJECT_DOCUMENT_ROOT . '/modul/' . $modul . '/' . $modul . '.php';
    $target = PROJECT_HTTP_ROOT . $target;
    if( is_file($file) and $use['mod_' . $modul] == 1 ) {
        $title = $modul;
        return $this->make_link($target, $inscription, $query_str_arr, $title);

    }else{
        if (isset($_SESSION['hide_inactive_mod']) and $_SESSION['hide_inactive_mod'] != 1) {
            $title = 'Modul ' . $modul . ' nicht aktiv';
            $this->inactive();
            return $this->make_link($target, $inscription, $query_str_arr, $title);
        }
    }
}

} // end class