<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


 /**
  * Class for sort positions automaticly
  *
  * @since      08/2011
  */

class Sort_Pos extends Dbc
{
    private $id;
    private $change_range = true;
    private $pos_regarding;
    private $pos_should_be;
    private $foreign_key;
    private $operator_value;
    private $tbl;

    
/**
 * Change positions with sql
 */
function change_positions_up()
{
    if ($this->change_range == true) {
        
        // change item regarding
        $sql = "UPDATE $this->tbl SET item = '$this->pos_should_be'
                WHERE id = $this->id";
        $this->do_sql($sql);

        // If new position is lower
        if ($this->pos_should_be < $this->pos_regarding) {
            $operator = "+" . $this->operator_value;
            $from = " >= $this->pos_should_be ";
            $to = " < $this->pos_regarding ";

        // or new position is higher   
        }  else {
            $operator = "-" . $this->operator_value;
            $from = "> $this->pos_regarding";
            $to = "<= $this->pos_should_be";
        }

        // change item in this range
        $sql = "UPDATE $this->tbl SET item = item $operator
                    WHERE id_tbl_order = $this->foreign_key
                    AND item $from  
                    AND item $to
                    AND id != $this->id";
        $this->do_sql($sql);
    }
}


/**
 *
 * @param type $tbl
 * @param type $id
 * @param type $foreign_key
 * @param type $pos_is
 * @param type $pos_should_be 
 */
function set_values($tbl, $id, $foreign_key, $pos_is, $pos_should_be)
{
     $this->pos_regarding = $pos_is;
     $this->pos_should_be = $pos_should_be;
     $this->foreign_key = $foreign_key;
     $this->tbl = $tbl;
     $this->id = $id;
     $this->operator_value = "1";
     
     $decimal = strstr($this->pos_regarding, '.');
     
     if ($decimal == true) {
         $this->change_range = false;
         echo 'false';
     }
}


} // end class