<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/**
 * Class for showing database content in a table.
 * You can edit each record by pressing the ID.
 * This class will splitt the result to several sites with forward-
 * and back buttons (pagination)
 * 
 * You can set the number of rows on each site.
 *
 * This class requires:
 *    * a SESSION
 *    * the class Dbc
 *    * the class Link
 *
 * @since 2010-08
 *
 */
class Tbl extends Dbc 
{
    private $amount_field; // query
    
    private $query; // query
    private $query_count; // query
    private $number_of_rows_all;
    private $arr_fields = array(); // fields from the query without alias
    private $arr_id_link = array(); // key and value for query string of link
    private $condition_total; // condition for total number of rows
    private $col_value2;     // id_name2
    private $date_format = 'y-m-d';
    private $field_as_link = 'id';
    private $fields_double_width = array();
    private $field1_total; // field for calculation of total, f.i. field1
    private $field2_total; // field2 for calculation of total, f.i. field1*field2
    private $deleted = 'hide'; // name of bool field hide or not
    private $id_field = 'id'; // data field name of id
    protected $id_name_link = 'id';
    private $id_name_link2 = 'mat_id';
    protected $limit = 10; // the limit of records on each site
    protected $limit_start = 0;
    private $link_addition = ''; // addition behind the link
    private $link_target = 'tbl_edit.php';
    private $link_inscription;
    private $link2_id_ein = 0; // zeigt im link2 im querystring id=... oder nicht
    private $pagination_bottom = 26;
    private $image_path = IMAGE_SHOP_HTTP;
    private $query_string;
    private $rm_link = 1; // display the waste-paper-basket = 1
    private $column_width = '150';
    private $row_color = '';
    private $td_align = '';
    private $unset_column;
    private $target; // file target
    private $to_many_rows; // file target
    private $reduce_result = false; // file target
    private $link_head_on = true; // show link in th of table


    
/**
 * Show the whole table
 *
 * @global type $la_hidden
 * @global type $arr_salutation
 * @global type $la_row_edit
 * @global type $worker
 * @global type $adm
 * @global type $la_payed
 * @global type $la_delivered
 * @return type 
 */
function show_table()
{
    $this->set_limit_start();
    $this->set_rows_total();
    print $this->print_from_to();
    if ($this->to_many_rows == true and $this->reduce_result == true) {
        return false;
    }
    $this->print_total();
    $this->show_table_head();

    global $la_hidden;
    global $arr_salutation;
    global $la_row_edit;
    global $worker;
    global $adm;
    global $la_payed;
    global $la_delivered;
    ?>
    <script type="text/javascript">
        function highlight(obj)
        {
           if(obj.className == "row1" || obj.className == "row2" || obj.className == "")
              obj.className = "row";
           else
              obj.className = '';
        }
    </script>

    <?php
    if ($this->reduce_result == true) {
        $limit_start_limit = '';
    }else{
        $limit_start_limit = ' LIMIT ' . $this->limit_start . ',' .  $this->limit;
        
    }
    $this->query .= $limit_start_limit;

    $result_query = $this->query($this->query);
    $i_bg = 0;

    
    $iii = 1;
   // table content
   while ($row = $this->fetch_array($result_query, 'assoc')) {
        $i = 0;

        // display deleted records red
        $i_bg++;
        if (  (isset ($row[$this->deleted]) and $row[$this->deleted] == 1 )  ) {
                $this->set_row_color($row[$this->deleted] == 1);

        // display payed records green
        }elseif( (isset ($row[$la_payed]) and  $row[$la_payed] > 1) 
                and 
                (isset ($row[$la_delivered]) and $row[$la_delivered] > 1)
        ) {
            $this->row_color = ' class="bcolor_green"';
            
        // all other records
        }else{
            if ($i_bg % 2 == 0) {
                $this->row_color = ' class="row1"';
            }else{
                $this->row_color = ' class="row2"';
            }
        }
        
        // Highlight row
        print "<tr onclick=\"highlight(this);\" $this->row_color>\n";
        // rows
        foreach ($row as $col => $value) {
           if ($col != $la_hidden and $col != $this->unset_column) {

                // align content
                $field_type = $this->get_field_type($result_query, $i);
                $this->set_td_align($field_type);

                // start cell
                print '<td ' . $this->td_align . ' title="' . $value . '">';

                // format date
                if($field_type == 'date' or $field_type == 'timestamp') {
                    if ($value == '0000-00-00' or $value == null) {
                        // empty date
                         $i2 = '--';
                    }else{
                        $date = new DateTime($value);
                        $i2 = $date->format($worker['time_format_list']);
                        if (strlen ($i2) < 6) {
                            $i2 = $date->format($this->date_format);
                        }
                    }

                }elseif($col == $this->fields_double_width) {
                    $l2 = 2 * $this->column_width;
                    $i2 = substr($value, 0, $l2);

                // alias of id_tbl_salutation
                }elseif($col == 'Anrede') { 
                    $i2 = $arr_salutation[$value];

                }else{
                    $i2 = substr($value, 0, $this->column_width);
                }
                
                // if string is too long "..." will be added
                if(strlen($value) > $this->column_width and $col != 'Datum') {
                    $usw = '...';
                }else{
                    $usw = '';
                }
                
                if ($col == $this->id_field) {
                    $id2 = $row[$this->id_field];
                }

                // Link
                if($col == $this->field_as_link) {
                    $id2 = $row[$this->id_field];
                    
                    // array with get parameters
                    $id_name = $this->id_name_link;
                    $this->arr_id_link[$id_name] =  $id2 ;
                    $link = new Link();
                    $link->set_class('action');
                    print $link->make_link( $this->link_target, $value . $this->link_addition, 
                            $this->arr_id_link, $la_row_edit);

                // Image
                }elseif($col == 'url' and !empty($value) ) {
                    print '<img src="' . $this->image_path . '/' . $value 
                        . '" height="25">';
                
                // Other
                }else{
                    print   $i2 . $usw ;
                }
                
                print "</td>\n";
           } // end not deleted
           
            $i++;
        } // end foreach
        
        // advance of order. Must be implemented in an own class(Tbl_advance)
        if (isset($id2)) {
            $this->advance($id2);
        }

        // hide link
        if (isset ($row[$this->deleted])) {
            $this->print_column_delete(2, $row[$this->id_field], $row[$this->deleted]);
        }

        /**
         * Link 2
         */
        if (isset($row[$this->col_value2])) {
            $value2 = $row[$this->col_value2];
        }elseif(isset($row[$this->id_field])) {
            $value2 = $row[$this->id_field];
        }else{
            $value2 = '';
        }
        $this->get_link2($value2);

        print "\n</tr>\n";
        
      // return the amount of the fields
      $this->print_sum_row($row, $this->query, $iii);
      $iii++;
    } // end while

    // if limit > 20, display navigation also at the bottom
    if ($this->limit > $this->pagination_bottom) {
         $this->pagination();
    }
    print '</table>';
}


/**
 * Creates table head with headlines
 *
 * @global type $la_hidden
 * @global type $la_order 
 */
function show_table_head() 
{
    if ($this->number_of_rows_all > 0) {
        global $la_hidden;
        global $la_order;
        
        $form_target = $_SERVER['PHP_SELF'];
        $query = $this->query . ' LIMIT 1';
        $result_query = $this->query($query);
        print '</div>';
        ?>
        <style type="text/css">
            .row1{ background-color: #E3E3E3; }
            .row2{ background-color: #F3F3F3; }
        </style>
        <?php
        print "\n" . '<table>';
        $this->pagination();

        print '<tr>';
        $k = 0;
        while ($row = $this->fetch_array($result_query, 'assoc')) {
            foreach ($row as $col => $value) {
                if ($col != $la_hidden  and $col != $this->unset_column) {
                    print '<th>';
                    // cut string on the end
                    $f = substr($col, 0, $this->column_width); 

                    $number_of_characters = strlen($f);
                    $half = $number_of_characters / 2;
                    
                    $col_not_for_url = $this->arr_fields[$k];
                    $col_for_url = urlencode($this->arr_fields[$k]);
                    
                    $arr = array('order' => $col_for_url );
                    
                    if(isset($_SESSION['search_mod'])) {
                        $arr['search_mod'] = $_SESSION['search_mod'];
                    }
                    
                    /**
                     * Necessary for prevent errors after sort a columen, switch
                     * to another table and press the browser back button
                     */
                    if(isset($_SESSION['tbl'])) {
                        $arr['tbl'] = $_SESSION['tbl'];
                    }
                    
                    // Link for order column
                    $link = new Link();
                    
                    if ($this->number_of_rows_all < 2) {
                        $link->inactive();
                    }
                    if ($this->link_head_on == false) {
                        $link->inactive();
                    }
                    
                    // First half of headline
                    $half_1 = substr($f, 0, $half); 
                    $arr['order_dir'] = 'ASC';
                    $link->set_class_or_style('style');
                    #echo $arr['order'];
                    print  $link->make_link($form_target, $half_1, $arr);

                    // Second half of headline
                    $half_2 = substr($f, $half); 
                    $arr['order_dir'] = 'DESC';
                    print  $link->make_link($form_target, $half_2, $arr);
                    
                    if (isset($_SESSION['order']) and $_SESSION['order'] == $col_not_for_url) {
                        print '<span style="color:red;">';
                        if (isset($_SESSION['order_dir']) and $_SESSION['order_dir'] == 'DESC') {
                            print '&darr;'; // Arrow down
                        }else{
                            print '&uarr;'; // Arrow up
                        }   
                        print '</span>';
                    }
                    print "</th>\n";
                } // end if != hide
                    $k++;
            } // end foreach
        } // end while

        // Order timeline
        if(isset($_SESSION['todo'])) {
            print '<th style="width:170px">' . $la_order . '</th>';
        }

        // Display or hide
        if (!empty ($this->deleted)) {
            $this->print_column_delete(1);
        }

        if (!empty ($this->target)) {
            print '<th></th>';
        }
        print '</tr>';
    }
}



/**
 * Function for more function
 *
 * @param type $id 
 */
function advance($id)
{
    // To be implemented in inherited class
}


/**
 * Sets condition and two fields for calculation of total sum
 * For instance amount * price for one piece 
 *
 * @param type $condition
 * @param type $field1
 * @param type $field2 
 */
public function set_total($condition, $field1, $field2='') 
{
    $this->condition_total = $condition;
    $this->field1_total = $field1;
    $this->field2_total = $field2;
}


/**
 * Prints total amount of the query, f.i. total invoice amount of all
 * orders from this query
 * 
 * @global type $la_sum
 * @global type $use 
 */
function print_total() 
{
    global $la_sum;
    global $use;
    // DISPLAY AMOUNT
    if($this->condition_total) {
        $db_sum = new Db_Total($use['db_e']);
        $aus_summe = $db_sum->rows_total($this->query, $this->field1_total, 
                $this->field2_total);

        print '<p style="display:inline;"><span class="small">'
        . $la_sum.': ' . number_format($aus_summe, 2, ",", ".") . '</span></p>';
    }
}


/**
 * Returns current limit-start and total of rows
 * f.i. "20 - 40 of 107 records
 *
 * @global type $la_records
 * @global type $la_from 
 */
private function print_from_to() 
{
    if ($this->number_of_rows_all > 0) {
        global $la_records;
        global $la_from;
        
        if ($this->limit_start > 0) {
            $start = $this->limit_start + 1;
            
        }else{
            $start = 1;
        }

        $end = $start + $this->limit - 1;
        if ($end >= $this->number_of_rows_all) {
            $end = $this->number_of_rows_all;
        }
        
        // Dont print from-to in look window
        $output = '';
        if ($this->reduce_result == false) {
            $output .= $start . ' - ' . $end;
            $output .= ' ' . $la_from . ' ';
        }
        $output .= $this->number_of_rows_all . ' ' . $la_records;
        
        return '<div style="display:inline;">
        <span class="small"> ' . $output . '</span></div>';
    }
}


/**
 * Split result to several pages
 *
 * ! Before use: set limit
 *
 * @global  $la_next
 * @global type $la_back
 * @return type 
 */
private function pagination() 
{
    global $la_next;
    global $la_back;
    global $la_one_page;
    
    if ($this->reduce_result == true) {
        return false;
    }
    // Set number of pages in the middel, for example 3: 1...8 9 10 ...56
    $pages_in_the_middle = 14;
    // Set middle of current page of link_anzahl_max. in example case = 9
    $offset = ceil($pages_in_the_middle/2) - 1;

    // Split result to different pages
    if($this->number_of_rows_all > $this->limit) {

        // Number of all pages
        $pages = $this->number_of_rows_all / $this->limit;
        $pages = ceil($pages);
        ?>
        <tr>
        <td colspan="20">
        <?php
        if ($this->limit_start >= $offset) {
            $page_start = ($this->limit_start / $this->limit)-$offset;
        }else{
            $page_start = 1;
        }

        // Set page number end
        $page_end = $page_start + $pages_in_the_middle;

        // Prevent page number less 1
        if ($page_start <= 0) {
           $page_start = 1;
        }

        // Prevent page number more than max
        if ($page_end > $pages) {
           $page_end = $pages;
        }


        $link = new Link();
        
        // Current page setting
        if (isset ($_REQUEST['page'])) {
            $current_page = $_REQUEST['page'];
        }elseif(isset($_SESSION['page'])) {
            $current_page = $_SESSION['page'];
        }else{
            $current_page = 1;
        }
        ?>
        <style type="text/css">
            a.link_invert:link, a.link_invert:visited, a.link_invert:hover{
                background-color: #5d976b;
                color: white;    
            }
        </style>
        <?php
        
        /**
         * Loop to create buttons and links for all pages
         */
        for($i=$page_start; $i<=$page_end; $i++) {
            // Calculate limit_start
            $limit_start = ($i - 1) * $this->limit;
            
            // Array with get parameters
            $arr = array('page' => $i);

            if(isset($_REQUEST['todo'])) {
                $arr['todo'] = 1;
            }
            
            // Link with current page
            if($i == $current_page) {
                $link->set_class('link_invert');
            }else{
                $link->set_class();
            }
            // Button back without function
            if ($current_page == 1 and $i == $page_start) {
               ?>
                <input style="color:silver;" type="submit" name="button"
                       value="< <?php print $la_one_page . ' '.$la_back; ?>">
               <?php

           // Button back
            }elseif( $i == $page_start ) {
                ?>
                <!--zurueck-->
                <form method="post" style="display:inline">
                <input type="submit" name="button"
                       value="< <?php print $la_one_page . ' '. $la_back; ?>">
                <input type="hidden" name="page" 
                       value="<?php print $current_page - 1; ?>">
                </form>
                <?php
            }

            // Forward button without function
            if ($current_page == $pages and $i == $page_start) {
               ?>
                <input style="color:silver;" type="submit" name="button"
                       value="<?php print $la_one_page . ' '. $la_next; ?> >">
               <?php

            // Forward button
            }elseif( $i == $page_start ) {
                ?>
               <!--forward-->
                <form method="post" style="display:inline">
                <input type="submit" name="button"
                           value="<?php print $la_one_page . ' '. $la_next; ?> >">
                <input type="hidden" name="page" 
                       value="<?php print $current_page + 1; ?>">
                </form>
                <?php
            }

            // First page when 1 ... 
            $file = $_SERVER['PHP_SELF'];
            if ( $page_start > 2 and $i == $page_start) {
                $arr5 = array('page' => 1);
                print $link->make_link($file, 1, $arr5) . ' ';
                print ' ... ';
            }

            // Middle pages
            print $link->make_link($file, $i, $arr) . " \n";
        } // end for

        // Last page
        if ($current_page <=  $pages-($pages_in_the_middle-$offset) ) {
            print ' ... ';
            $arr6 = array('page' => $pages );
            print $link->make_link($file, $pages, $arr6) . ' ';
        }
        ?>
        </td>
        </tr>
        <?php
    }
}


/**
 * Get total number of records from the query
 * NOTICE: Use mysql COUNT(*) for good performance in case of many records!
 * In case of 100.000 records: 13s vs. 0.5s
 * 
 * @global string $la_empty_result 
 */
function set_rows_total() 
{
    global $la_empty_result;
    
    if (isset($this->query_count)) {
        $result =  $this->query($this->query_count);
        while($row = $this->fetch_array($result)) {
            $anz[] = $row['COUNT(*)'];
        }
        $quantity = $anz[0];
        
    // count_rows() is much much much more slowly than mysql COUNT(*)
    }else{
        $quantity= $this->count_rows($this->query);
    }
    
    $this->number_of_rows_all = $quantity;
    
    if ($this->number_of_rows_all < 1) {
        print '<h3 class="red">' . $la_empty_result . '</h3>';
    }elseif($this->number_of_rows_all > 200 and $this->reduce_result == true) {
        $info = new Info_Box();
        $text = $this->number_of_rows_all. ' '.$GLOBALS['la_result_large'];
        $info->show_box($text);
        $this->to_many_rows = true;
    }
}


/**
 *
 * @param int $limit Limit of query
 */
  public function set_limit($limit) 
{
    if(empty($limit)) {
        $this->limit = 10;
        
    }else{
        $this->limit = $limit;
    }
}


/**
 *
 * @param int $start Limit start of query
 */
function set_limit_start() 
{
    if (isset ($_REQUEST['page'])) {
        $start = ($_REQUEST['page'] - 1) * $this->limit;
    
        if(empty($start)) {
            $this->limit_start = 0;

        }else{
            $this->limit_start = $start;
        }
    }
}


/**
 * Color deleted records red
 * 
 * @param str $condition Condition for coloring
 */
function set_row_color($condition)
{
    if ($condition) {
        $this->row_color = ' class="bcolor2" ';
        
    }else{
        $this->row_color = '';
    }
}


/**
 * Sets field alignment depend on field type
 * 
 * @param type $field_type 
 */
private function set_td_align($field_type)
{
    if($field_type == 'real' or $field_type == 'double') {
        $this->td_align = 'align="right"';
        
    }elseif($field_type == 'int') {
        $this->td_align = 'align="center"';
        
    }else{
        $this->td_align = '';
    }
}


/**
 * Set column width
 *
 * @param type $column_width 
 */
function set_column_width($column_width)
{
    $this->column_width = $column_width;
}


/**
 * Set fields with double column widht
 * 
 * @param str $value bedingung, 1 = id als link zeigen, 0= id nur als zeichen
 */
function set_field_double_width($value, $condition = 1)
{
    if ($condition) {
        $this->fields_double_width = $value;
    }
}


/**
 * Set field witch contains primary key with autoincrement
 * 
 * @param str $value Hier wird der Feldname eingesetzt, der als link dargestellt werden soll
 */
function set_id_field($value, $condition = 1)
{
    if ($condition) {
       $this->id_field = $value;
    }
}

function set_fields($arr_fields)
{
       $this->arr_fields = $arr_fields;
}


//------ set link 1 -------------------------------------------------
/**
 * Set field witch contains primary key with autoincrement
 *
 * @param string $value fieldname which is displayed as a link
 * @param type $condition 
 */
function set_link_id_name_in_querystr($value, $condition = 1)
{
    if ($condition) {
        $this->id_name_link = $value;
    }
}


/**
 * Set which field would be the link
 * 
 * @param str $value Field name, for the link
 * @param str $condition, 1 = show id as link, 0= id without link
 */
function set_field_as_link($value, $condition = 1)
{
    if ($condition) {
       $this->field_as_link = $value;
    }
}


/**
 * Set target file from link
 * 
 * @param str target file
 * @param type $condition Condition for setting
 */
function set_link_target($target, $condition = 1) 
{
    if ($condition) {
        $this->link_target = $target;
    }
}


/**
 * set query string values in the link
 *
 * @param array $array key an value like 'table' => 'adr' etc.
 * @param type $condition condition for the array
 */
function set_link_queryarr($array, $condition = 1)
{
    if ($condition) {
        $this->arr_id_link = $array;
    }
}


/**
 * Displays an additon behind the link f.i. 25 "addition"
 *
 * @param str $add addition behinde the link
 */
function set_link_addition($add) 
{
    $this->link_addition = $add;
}




//------- set link 2 ------------------------------------------------------
/**
 * Set the id name in the querystring f.i. 'blabla'=88 or 'blubb'=88
 * 
 * @param str $value Hier wird der Feldname eingesetzt, der als link dargestellt werden soll
 */
function set_link2_id_name_in_querystr($value)
{
    $this->id_name_link2 = $value;
}


/**
 * parameters for second link (link2)
 *
 * @param type $target target file
 * @param type $query_string query string
 * @param type $inscription text
 */
function set_link2($target, $query_string, $inscription)
{
    $this->target = $target;
    $this->query_string = $query_string;
    $this->link_inscription = $inscription;
}


/**
 * id= ... put in querystring or not, default is 0
 * 
 * @param str $param 1=yes show id in querylink, 0=don't show id
 */
function set_link2_id_in_querystr($param)
{
    $this->link2_id_ein = $param;
}


/**
 * Second link in the table
 * @param <type> $id2
 */
private function get_link2($id2)
{
    if (!empty ($this->target)) {
        if ($this->link2_id_ein == 1) {
            $id_ein = '&id=' . $id2;
        }else{
            $id_ein = '';
        }

        print '<td>';
        print '<a href="' . $this->target . '?' . $this->query_string . '&'
                . $this->id_name_link2 . '=' . $id2 . $id_ein . '">' 
                . $this->link_inscription . '</a>';
        print '</td>';
    }
}


//-------------------------------------------------------------------------


/**
 * Sets variable, if copied link will be displayed
 * 
 * @param int $value 1=ja, 0=nein
 */
function hide_delete_link($value=0)
{
    $this->rm_link = $value;
}


/**
 * Delete field is the field with value 0 or 1 for display or hide record
 * 
 * @param <type> $value Name des Feldes hide setzen (f?r loeschen_link)
 */
function set_name_of_delete_field($value)
{
    $this->deleted = $value;
}


/**
 * 
 *
 * @param str $condition
 * @param str $column
 */
function set_col_value2( $column, $condition=1 )
{
    if ($condition) {
        $this->col_value2 = $column;
    }
}


/**
 * Set the query
 * @param str $query
 */
function set_query( $query ) 
{
    $this->query = $query;
}


/**
 * Set query for count records 
 * without fieldname but COUNT(*)
 * 
 * @param str $query
 */
function set_query_count( $query ) 
{
    $this->query_count = $query;
}


/**
 * Hide column, but value is needed
 *
 * @param str $condition
 * @param str $column
 */
function unset_field($condition, $column ) 
{
    if ($condition) {
        $this->unset_column = $column;
    }
}


/**
 * Hide column, but value is needed
 *
 * @param type $bool 
 */
function reduce_result($bool=true) 
{
        $this->reduce_result = $bool;
}


/**
 * Display column with the dustbin
 *
 * @global type $la_record_hide
 * @global type $use
 * @param type $th_td
 * @param type $id
 * @param type $value 
 */
function print_column_delete($th_td, $id='', $value='') 
{
    global $la_record_hide;
    global $use;
    
    if($this->rm_link == 1) {
        if ($th_td == 1) {
            print '<th title="'.$la_record_hide.'"></th>';

        }elseif($th_td == 2) {
            print '<td style="text-align:center">';
            $arr3 = array();
            if (isset ($_SESSION['value1'])) {
                $arr3 = array( 'value1' => $_SESSION['value1'] );
            }

            if (isset($_REQUEST['todo'])) {
               $arr3['todo'] = 1;
            }

            // dustbin
            $dbin = new Dustbin( $use['db_e']);
            $dbin->set_table($_SESSION['tbl']);
            print $dbin->show_dustbin($id, $value, $arr3);
            print '</td>';
        }
    }

}


/**
 * Test
 * 
 * @global type $style
 * @global type $use
 * @param type $row
 * @param type $sql
 * @param type $i 
 */
function print_sum_row($row, $sql, $i) 
{
   global $style;
   global $use;
   $style2 = 'style="font-weight:bold;"';
  // return the amount of the fields
  if ($i == $this->number_of_rows_all and !empty($this->amount_field)) {
      print '<tr style="border-top: 1px solid gray;">';
            foreach ($row as $key => $value) {
                $check = FALSE;

                // check if elements of the array according to the field
                for ($ii=0; $ii < count($this->amount_field); $ii++) {
                    if ($this->amount_field[$ii] == $key) {
                        $check = TRUE;
                    }
                }

                // if not according, print empty field
                $cell = new Html_Element();
                $cell->set_th_td(2);
                print $cell->tdh(!$check, '&nbsp;', $style);

                // if according print total
                if ($check) {
                    $db = new Db_Total($use['db_e']);
                    $total = $db->rows_total($sql, $key);
                    $total_format = number_format($total, 2, ",", ".");
                    print $cell->tdh($check, $total_format, $style2);
                }
            }
      print '</tr>';
  }
}


/**
*
* @param array $param array mit den feldnamen, die als summen angezeigt werden sollen
*/
function set_sum_field($param) 
{
   $this->amount_field = $param;
}

/**
*
* @param array $param array mit den feldnamen, die als summen angezeigt werden sollen
*/
function set_link_head_on($bool) {
   $this->link_head_on = $bool;
}


} // end class