<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

session_start();

if (isset($_POST['lang']) and $_POST['lang'] == 'en') {
    $_SESSION['lang'] = 'en';
    $check_en = 'checked';
    $check_de = '';

}else{
    $_SESSION['lang'] = 'de';
    $check_en = '';
    $check_de = 'checked';
}

// Projekt path
define('PROJECT_DOCUMENT_ROOT', dirname(__FILE__));

/**
 * Includes
 */
require_once 'config.php';
require_once 'config_db.php';
require_once 'class/dbc.class.php';


$path_class = PROJECT_DOCUMENT_ROOT . '/class/';
$path_include = PROJECT_DOCUMENT_ROOT . '/include/';

// Autoload of classes
function __autoload($class)
{
    global $path_class;
    $class = strtolower($class);
    require_once $path_class . $class . '.class.php';
}

/**
 * Local system without login
 */
if (LOCAL_SYSTEM == true) {
    $_SESSION['use_id'] = 1;
    $_SESSION['time'] = time();

    // Pipe
    header("Location: center.php?zen=1&bea_search=1&new=1");
    exit ();
}


if ($_SESSION['lang'] == 'de') {
    require_once 'lang/german.inc.php';
}elseif($_SESSION['lang'] == 'en') {
    require_once  'lang/english.inc.php';
}


if (isset($_REQUEST['login_button'])) {

    /**
     * Cut user input to maximal 50 and 32 charakters
     * Security to male code
     */
    $post_email_50 = trim(substr($_REQUEST['email'], 0, 50));
    $post_password_32 = substr($_REQUEST['password'], 0, 32);

    /**
     * Function, to get the part of the string before needle:
     * in this case email-address without operator.
     * 
     * @param <type> $h
     * @param <type> $n
     * @return <string>
     */
    function strstrb($h,$n) {
        $arr = explode($n, $h, 2);
        return array_shift($arr);
    }
    
    $post_email_50_ohne_bearbeiter = strstrb($post_email_50, ' ');

    // extract operator from login
    $worker = trim(strstr($post_email_50, ' '));
    $_SESSION['bea_username'] = $worker;

    // Password to md5
    $password_md5 = md5($post_password_32);

    /**
     * get user as array $use3[login_name] etc.
     */
     $use2 = new Dbc();
     $use = $use2->get_row_as_array('tbl_0_user', "email = '".$post_email_50_ohne_bearbeiter."'");
     #print_r($use3);
      if (empty($use)) {
         $use3_empty = 1;
      }else

    if (isset($_REQUEST['password']) && $password_md5 == $use['pw']) {
        /**
         *  Checking
         */
        if (!isset($file6)) {
            $file6 = 'sff.php';
        }

        if (is_file($file6)) {
            require_once $file6; 
        }elseif(LOCAL_SYSTEM == true) {
            $key77 = 'faktura';
            $value77 = 'ok'; 
        }

        /**
         * Set session vars
         */
        $_SESSION[$key77] = $value77;
        $_SESSION['user'] = $use['email'];
        $_SESSION['use_id'] = $use['id'];
        $_SESSION['mod_expense'] = $use['mod_expense'];
        $_SESSION['mod_anfrage'] = $use['mod_anfrage'];
        $_SESSION['mod_kalku'] = $use['mod_kalku'];
        $_SESSION['lang'] = $_POST['lang'];
        $_SESSION['time'] = time();
        $_SESSION['time_info'] = time();

        
        // db log
        if (is_file($file_db)) {
            require_once $file_db; 
        }

        // Pipe
        header("Location: center.php?zen=1&bea_search=1&new=1");

    /**
     * False login
     */  
    }else{
        $false_login = 1;
    }
}
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
<link rel="stylesheet" href="css/default.css" type="text/css">
<title>schreinerwissen. auftragsverwaltung</title>
</head>
<body style="background: white;" onload="document.login.email.focus()">
<?php
if (isset($_REQUEST['logout'])) {
    unset($_SESSION[$key77]);
}


?>
<div class="standard900">
    <div style="width:470px;" class="center">
        
    <?php print $headline_base; ?>

    <p><?php print $la_calculation_and_faktura; ?></p>
    <p>&nbsp;</p>

    <?php

    /**
     * SERVICE
     */
    if (SERVICE == true) {
        ?>
        <h1>Wartungsarbeiten. Wir sind bald wieder online.</h1>
        <p>&nbsp;</p>
        <img src="http://www.schreinerwissen.de/images/holzi_r_xl_2.png" width="100px">
        <?php

        
    /**
     * FORM
     */
    }else{
     ?>
    <form name="language" method="post" action="index.php">
    <input type="radio" <?php print $check_de; ?> name="lang" value="de"
           title="Sprache" onchange="this.form.submit();" >deutsch
    <input type="radio" <?php print $check_en; ?> name="lang" value="en"
           title="Sprache" onchange="this.form.submit();" >english
    </form>
    
    <form name="login" method="post" action="index.php">
    <input type="text" checked name="email" size="40" maxlength="50" /> <?php print $la_email_address; ?>
    <img src="image/info.png"
     title="An den Benutzernamen (vollst&auml;ndige E-Mail Adresse) kann der Bearbeiter
     getrennt von einer Leerstelle geh&auml;ngt werden" alt="Info">
    <br/>
    <br/>
        <input type="password" name="password"  maxlength="50" > <?php print $la_password; ?> 
    <br/>
    <br/>
        <input type="submit" name="login_button" value="<?php print $la_login; ?>" >
    <br/>
    <br/>
        <input type="hidden" name="lang" value="<?php print $_SESSION['lang']; ?>" >
    <br/>
    <br/>
    </form>
        <br>
        
<?php
     #require_once 'development/pw_forgotten.inc.php';
    }
//phpinfo();
    $info  = new Info_Box();
if (isset($false_login)) {
   $text = 'Die Daten waren falsch.';
   $html = new Html_Element();
   echo $info->show_box($text);
   
}  elseif (isset($use3_empty)) {
   $text = 'Userdaten nicht gefunden.';
   $html = new Html_Element();
   echo $info->show_box($text);
}
?>
</div>
</div>
<script src="http://www.google-analytics.com/urchin.js" type="text/javascript">
</script>
<script type="text/javascript">
_uacct = "UA-1763608-1";
urchinTracker();
</script>

</body>
</html>