<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


 /**
  * Edit orders
  *
  *
  * Required classes: 
  *     Bool_Switch
  *     Go_Forward
  *     Dustbin
  *     Order_Edit
  *     Sort_Pos
  *     Menu
  *     Link_Menu
  * 
  * @since      2010-12
  * 
  */

require_once 'common.php';
$arr_unset = array('todo');

foreach ($arr_unset as $value) {
    unset ($_SESSION[$value]);
}

$file_order_edit = 'order_edit.php';

// Delete adr_old
unset ($_SESSION['adr_old']);

// lock record if new=1
if (isset($_REQUEST['new']) and $_REQUEST['new'] == 1) {
    unset ($_SESSION['anyway']);
}

unset ($_SESSION['select_deliverer']);


/**
 *  Copy hole calculation
 */
$copy_calc_file = 'modul/copy/copy_calc.inc.php';
if (is_file($copy_calc_file)) {
    require_once $copy_calc_file ;
}

/**
 *  Copy hole order
 */
$copy_file = 'modul/copy/copy_order.inc.php';
if (is_file($copy_file)) {
    require_once $copy_file ;
}


/**
 * Edit offer values
 */
// -----------------------------------------------------------------------------
    
    // Condition for changing
    $condition = '';
    if (isset($_SESSION['auf_id'])) {
        $condition = "id_tbl_order = " . $_SESSION['auf_id'];
    }

    $condition .= " AND hide != 1";

    // offer, order_conf, invoice, delivery 
    $array = array('offer', 'order_conf', 'invoice', 'delivery', );
    foreach ($array as $key => $value) {
        if (isset($_GET[$value])) {
            $wert = abs($_GET[$value]-1);
            $data = array($value => $wert);
            if( isset($_GET['auf_pos_id'])) {
                if (isset($_GET[$value]) and !isset ($_GET['all'])) {
                    // Set value
                    $db->update_array($tbl_ord_ite, $data, 'id=' . $_GET['auf_pos_id']);
                }
            }
            $all = $db->get_max($tbl_ord_ite, $value, $condition); // get a value
            $all = abs($all-1); // remove sign
            $data = array($value => $all);
            if (isset($_GET[$value]) and isset ($_GET['all'])) {
                $db->update_array($tbl_ord_ite, $data, $condition);
            }
        }
    } // ---------------------------------------------------+

    // After edit unset query_string, if not never ending loop
    if ( (  isset ($_REQUEST['offer']) 
            or isset ($_REQUEST['order_conf']) 
            or isset ($_REQUEST['invoice']) 
            or isset ($_REQUEST['delivery'])
          ) and !empty ($_SERVER['QUERY_STRING'])
        ) 
    {
        $go = new Go_Forward();
        $go->go_to_target($file_order_edit);
    }


HTML::printHead($css);

// Switch for cursor position
if (isset ($_GET['edit55'])) {
    $form_field = 'frm_change_ord_ite.description';
}else{
    $form_field = 'frm_insert_ord_ite.description';
}
HTML::printBody($form_field);
HTML::printHeadline($headline);

require_once 'include/bar_common.inc.php';

$bool = new Bool_Switch($use['db_e']);
$bool->set_table('ord');

if (isset($_SESSION['auf_id'])) {
    $bool->set_id($_SESSION['auf_id']);
}

$bool->set_field_name('invoice_gross');
$bool->set_content('Netto-Rechnung');
$bool->set_content('Brutto-Rechnung');
$bool->set_bool_query($tbl_ord);

// Dustbin
$dbin = new Dustbin($use['db_e']);
$dbin->set_dustbin('ord_ite');

// Insert data
$in = $db->insert_row($tbl);

// Order edit class
$order_edit = new Order_Edit($use['db_e']);


 /**
  * Put position to all documents
  */
if(isset ($_POST['insert_data']) and $in == true) {
    $max_id = $db->get_max($tbl, 'id');
    $sql = "
        UPDATE $tbl
        SET
            offer = 1,
            order_conf = 1,
            delivery = 1,
            invoice = 1
        WHERE id = $max_id";
    $db->do_sql($sql);
 }
  
 
 /**
  * Change order of item
  */
if(         isset ($_POST['change_data']) 
        and $_POST['item'] != $_POST['pos_old']
        and (isset($_POST['auto_sort']) and $_POST['auto_sort'] == 1)) 
{
    $sort_pos = new Sort_Pos($use['db_e']);
    $sort_pos->set_values(
            $tbl_ord_ite, 
            $_POST['id'], 
            $_SESSION['auf_id'], 
            $_POST['pos_old'], 
            $_POST['item']);
    $sort_pos->change_positions_up();
 }


// Set auf_id
if(     isset ($_GET['id']) 
    and !empty($_GET['id']) 
    and !isset ($_GET['hide_row'])) 
{
        $_SESSION['auf_id'] = $_GET['id'];
}

// Set order id from request
if(isset ($_REQUEST['auf_id'])) {
    $_SESSION['auf_id'] = $_REQUEST['auf_id'];
}

// id or number for orders
if (        $adm['own_doc_number'] == 1 
        and isset ($_POST['id_or_nr'])) 
{
    $id_or_nr = 'number';
}else{
    $id_or_nr = 'id';
}

// Form after submit: update
$db->update_row($tbl);

// Table with order data
require_once 'include/bar_order.inc.php';

?>
<div id="tab">
<?php
/**
 * Menu start
 */
$menu = new Menu();
$qry = "
    SELECT id 
    FROM $tbl_ord_ite 
    WHERE id_tbl_order = {$_SESSION['auf_id']}
    AND hide = 1";
$menu->show_hidden_records2($qry);

// Job order card
$target = 'modul/card/card.php';
$job_order_card = $link->make_link($target, $la_job_order_card);
$menu->add_more_content($job_order_card);

// Copy hole order
$arr = array ('copy_order' => 1,);
$copy_ord = new Link_Menu();
#$order_copy = $copy_ord->make_link('order_edit.php', $la_order_copy, $arr);
$order_copy = $copy_ord->insert_modul('copy', 'order_edit.php', $la_order_copy, $arr);
$menu->add_more_content($order_copy);
$menu->print_menu();

// Info order is copied
$text = $la_order_copied;
$info->set_inline(1);
$info->set_condition_request('copy_order', 4);
$info->show_box($text);

// Info calculation is copied
$text = $la_calc_copied;
$info->set_inline(1);
$info->set_condition_request('copy_calc', 4);
$info->show_box($text);

// Hint here you can create positions (article_select)
$number_of_rows_pos = $order_edit->get_number_of_rows();
$text = $la_item_new_form_hint;
$info->set_condition($number_of_rows_pos < 1 and $order['hide'] != 1);
$info->show_box($text);
    
// Get last position
$item = $order_edit->get_new_pos_nr();

// display form for new position only when order isn't finished
if ($order['payed'] < 1 and $order['hide'] != 1) {
    product_select_form($file_order_edit, 'ord_ite', $item, $address['id_tbl_client']);
}

// Hint here you can create positions
$text = $la_item_new_hint;
$info->show_box($text);
    
// Get last unit
$last_unit = $order_edit->get_last_unit();
?>
<table>
<tr>
    <?php
    // Kva_all-links
    $link->set_class('action');
    $kva_all = $link->make_link($file, $offer_1.' ', 'offer=1&amp;all=1',  $la_quotation_all);
    $kva_all .= $link->make_link($file, $order_conf_1.' ', 'order_conf=1&amp;all=1',  $la_set_order_conf_all);
    $kva_all .= $link->make_link($file, $deliv_1.' ', 'delivery=1&amp;all=1',  $la_delivery_all);
    $kva_all .= $link->make_link($file, $invoice_1, 'invoice=1&amp;all=1', $la_invoice_all);
    
    // Calculation
    $condition_calc = ($use['mod_calc'] == 1);
    $condition_tax = ($order['tax_on'] == 1);
    
    // Display copy column
    $condition_payed = ($order['payed'] < 1);
    $dustbin = '';
    if ($condition_payed) {
        $dustbin .= '<img src="image/waste.png" alt="muell" height="15px" width="15px"></img>';
    }
    
    // Condition copy
    $condition_copy = ($use['mod_copy'] == 1);
    
    //  Headline
    $html->set_th_td(1);
    $html->tdh(true, $la_pos);
    $html->tdh(true, $la_amount);
    $html->tdh(true, $la_unit_short);
    $html->tdh(true, $la_description);
    $html->tdh(true, $la_unit_price);
    $html->tdh(true, $la_total_price);
    $html->tdh($condition_tax, $la_tax_short);
    $html->tdh($condition_calc, $la_calcu);
    $html->tdh(true, $kva_all, 'width: 90px');
    $html->tdh(true, $dustbin);
    $html->tdh($condition_copy and $condition_payed, 'copy');
    ?>
</tr>
<?php

/**
 * New position
 */
if($condition_payed) {
    if (!isset ($_GET['edit55'])) {
        // Copy
        if (is_file('modul/copy/copy.php')) {
            require_once 'modul/copy/copy.php';
        }else{
            $copy_price = '';
        }
        ?>
        <tr>
            <?php
            $order_edit->print_row_with_form('insert');
            $html->tdh($condition_payed, '--');
            $html->tdh($condition_copy and $condition_payed, '--');
            ?>
        </tr>
        <?php
    
    }else{
        // Set empty row instead of form
        $i = 7;
        if ($condition_tax) { $i++;  }
        if ($condition_calc) { $i++;  }
        if ($condition_payed) { $i++; }
        if ($condition_copy and $condition_payed) { $i++; }
        show_empty_row($i, 4);
    }
} // end new

// empty row
?>
<tr style="background-color: transparent; height: 5px;">
    <td style="background-color: transparent;" colspan="8">
        <?php print $la_positions_inserted; ?>
    </td>
    <td style="background-color: transparent; text-align: center;" colspan="1">
        <img src="image/info.png" title="<?php print $la_positions_link; ?>">
    </td>
</tr>
<?php

/**
 * Query positions
 */
$hide = show_or_hide_deleted_records();

 // Fields order item
$auf_pos_fel_output = array(
    'item_follow',
    'item',
    'aufp.id',
    'id_tbl_order',
    'date_insert',
    'amount',
    'description',
    'sales_price',
    'offer',
    'order_conf',
    'delivery',
    'invoice',
    'id_tbl_product',
    'item_typ',
    'id_tbl_unit',
    'hide',
    'unit',
    'tax_a_b',
    'decimal_places',
    );

    $fields = $auf_pos_fel_output;

    // remove empty array elements
    unset_empty_array_elements($fields);

    $felder_str = implode(", ", $fields);
    
    $qry_auf_pos = "
        SELECT $felder_str
        FROM $rel_order_item_unit
        WHERE id_tbl_order = " . $order['id'] . " $hide
        AND item_typ >= 0
        AND item_typ != 5
        ORDER BY "
            
        // first part of positon f.i. 2.4 => 2
        . " CAST(SUBSTRING_INDEX(item, '.', 1) AS DECIMAL), "
                
         // second part of positon f.i. 2.4 => 4
        . " CAST(SUBSTRING_INDEX(item, '.', -1) AS DECIMAL) "
            
        . " ASC";
    $res_auf_pos = $db->query($qry_auf_pos);

/**
 * Loop with items
 */
while($auf_pos = $db->fetch_array($res_auf_pos)) {
    /**
     * Edit position
     */
    if(isset($_GET['edit55']) and $_GET['auf_pos_id'] == $auf_pos['id']) {
        $html->tr1();
        $order_edit->print_row_with_form();
        $html->tdh($condition_payed, '--'); 
        $html->tdh($condition_copy and $condition_payed, '--');
        $html->tr2();

    /**
     * Display Positions
     */
    }else{ 
        // Item
        $inscription = $auf_pos['item'] . $la_edit_for_link_addition;
        $arr7 = array(
        'tbl' => 'ord_ite',
        'id' => $auf_pos['id'],
        'auf_pos_id' => $auf_pos['id'],
        'auf_id' => $order['id'],
        'file' => $file_order_edit,
        'edit55' => 1,
        'anker' => '#a' . $auf_pos['id'],
        'item' => $auf_pos['item'],
        );
        $link = new Link();
        $link->set_class('action');
        $title = $la_pos . ' ' . $la_edit;  
        $item = '<a name="a' . $auf_pos['item'] . '"></a>';
        $item .= $link->make_link($file_order_edit, $inscription, $arr7 , $title);
        
        // Amount
        $amount = $order_edit->get_amount($auf_pos);
        
        // Unit
        $unit = '';
        if ($auf_pos['item_typ'] != 2) {
            $unit .= $auf_pos['unit'];
        }
        
        // Description
        $description = '';
        if($auf_pos['item_typ'] == 1) {
            $description .= '<span class="brown">Alternative:</span> ';
        }  
        if($auf_pos['item_typ'] == 3) {
            $description .= '<span class="brown">Eventuell:</span> ';
        }
        $description .=  $auf_pos['description'] ;
        $description .= ' ' . show_word_deleted($auf_pos['hide']);
        
        // Sales price
        $sales_price = '';
        if($auf_pos['item_typ'] == 0) {
            $sales_price .= $html->number_format($auf_pos['sales_price'], 2);
        }elseif($auf_pos['item_typ'] == 1) {
            $sales_price .= $html->number_format($auf_pos['sales_price'], 2);
        }
        
        // Total
        $total = '';
        if($auf_pos['item_typ'] == 0) {
            $g_preis = $auf_pos['amount'] * $auf_pos['sales_price'];
            $g_preis = number_format($g_preis, 2, ",", ".");
            $total .= $g_preis;
        }elseif($auf_pos['item_typ'] == 1) {
            $total .= '(alternativ)';
        }elseif($auf_pos['item_typ'] == 2) {
            $total .= '(Text)';
        }elseif($auf_pos['item_typ'] == 4) {
            $total .= '(Pos/Text)';
        }
        
        // Tax
        $condition_tax_rate = ($order['tax_on'] == 1);
        $tax_rate = '';
        if ($condition_tax_rate) {
            if ($auf_pos['item_typ'] == 0 or $auf_pos['item_typ'] == 1) {
                if($auf_pos['tax_a_b'] == 0) {
                    $tax_rate .= '-';
                }elseif($auf_pos['tax_a_b'] == 1) {
                    $tax_rate .= $order['tax_rate_a'] . '%';
                }elseif($auf_pos['tax_a_b'] == 2) {
                    $tax_rate .= $order['tax_rate_b'] . '%';
                }
            }else{
                $tax_rate .= '-';
            }
        }
        
        /**
         *  Calculation
         */
        $condition_calc = ($use['mod_calc'] == 1);
        $calc = '';
        if($condition_calc) {
            $target_file = 'modul/calc/calc.php';
            $file2 = PROJECT_DOCUMENT_ROOT.'/modul/calc/calc.php';
            
            // Select calculation image
            if( is_file($file2) and $use['mod_calc'] == 1 ) {
                $img_vers = '';
            }else{
                $img_vers = '2';
            }
            // Image for html
            $img = '<img src="' . PROJECT_HTTP_ROOT . 'image/calc' . $img_vers 
                 . '.jpg" border="none" width="14" height="16" >';

            // Insert modul
            $link_menu = new Link_Menu();
            $query_str = 'tbl=ord_ite&auf_pos_id=' . $auf_pos['id'] . '&kalku=kalku';
            $calc .= $link_menu->insert_modul('calc', $target_file, $img, $query_str);
            $calc .= ' ';

            // Check if there is a calculation
            $query5 = "SELECT id FROM $tbl_cal WHERE id_tbl_order_item =" . $auf_pos['id'];
            $number_of_calc = $db->count_rows($query5);
            // Green arrow
            if($number_of_calc > 0) {
                $calc .= '<img width="8" title="' . $la_calc_created . '" src="image/enable.png">';
                // Copy calculation
               $arr9 = array('copy_calc'=> 1, 'copy_calc_id'=> $auf_pos['id']);
               $calc .= ' ' . $link_menu->insert_modul('copy', $file, 'copy', $arr9);
            }else{
                $calc .= '-';
            }
            
        }
        
        /**
         *  Links for putting positions to documents
         */
        // offer
        $kva_links = '';
        $data = array( 'offer', $offer_1, $la_offer_set, $la_offer_unset, );
        $kva_links .= $order_edit->get_link_kva($data);

        // order confirmation
        $data = array( 'order_conf', $order_conf_1, $la_ord_conf_set, $la_ord_conf_unset, );
        $kva_links .= $order_edit->get_link_kva($data);

        // delivery note
        $data = array( 'delivery', $deliv_1, $la_delivery_set, $la_delivery_unset, );
        $kva_links .= $order_edit->get_link_kva($data);

        // invoice
        $data = array('invoice', $invoice_1, $la_invoice_set, $la_invoice_unset, );
        $kva_links .= $order_edit->get_link_kva($data);
        
        // dustbin and copy
        $dustbin = '';
        $mod_copy = '';
        if ($condition_payed) {
            // Dustbin
            $arr4 = array( 'auf_pos_id' => $auf_pos['id']);
            $dustbin .= $dbin->show_dustbin( $auf_pos['id'], $auf_pos['hide'], $arr4);

            // Copy
           $link->set_class('');
           $arr9 = array('copy'=> 1, 'copy_id'=> $auf_pos['id']);
           $mod_copy .= $link_menu->insert_modul('copy', $file, 'copy', $arr9);
        } // end if
        
        $html->tr1();
        $html->set_th_td(2);
        $html->tdh(true, $item);           
        $html->tdh(true, $amount);           
        $html->tdh(true, $unit);           
        $html->tdh(true, $description);           
        $html->tdh(true, $sales_price);           
        $html->tdh(true, $total);           
        $html->tdh($condition_tax_rate, $tax_rate);           
        $html->tdh($condition_calc, $calc);           
        $html->tdh(true, $kva_links); 
        $html->tdh($condition_payed, $dustbin); 
        $html->tdh($use['mod_copy'] == 1 and $condition_payed, $mod_copy);
        $html->tr2();
    } // end display positions and not new
} // end while item

?>
</table>
</div>
<?php
HTML::printFoot();
?>