<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Shows form for editing records
 */
require_once 'common.php';


$form = new Db_Form($use['db_e']);

/*
 * Form after submit
 */
if ( isset($_REQUEST['change_data']) and !isset ($_REQUEST['cp22']) ) {
    $form->form_after_submit();
    
}elseif(isset($_REQUEST['cp22']) and $_REQUEST['cp22'] == 1) {
    $form->form_after_submit_with_copy();


/**
 * Form before submit
 */
} else {
    // db_form class
    
    $form->set_address_change_value(); 
    $form->check_if_is_order_for_address();
    $form->save_address_change_in_new_record();


    HTML::printHead($css);
    HTML::printBody();
    HTML::printHeadline($headline);

    require_once 'include/bar_common.inc.php';
    
    // Link back
    print link_back_with_query('div');
    
    // Attention hint and color background when editing all fields
    if (isset($_REQUEST['edit']) and $_REQUEST['edit'] == 'all') {
        ?>
        <style type="text/css">
            div,td,th {
                background-color: yellow;
            }
        </style>
        <div style="background-color:orange; padding: 5px;">
        <h1>
            <?php print nl2br($la_attention_edit_all); ?>
        </h1>
        </div>
        <?php
    }
    
    
    ?>
    <form enctype="multipart/form-data" name="teo" method="post" action="tbl_edit.php">
    <?php

    // Fields
    $fields_for_query =  get_input_output_array('input');

    if (isset($_REQUEST['edit']) and $_REQUEST['edit'] == 'all') {
        $fields_for_query = '';
    }
    $form->print_warning_for_used_address_id();

    // Info for new record, tbl address
    if ($_SESSION['tbl'] == 'adr') {
        $info->set_condition_request('address_change', 3);
        $info->show_box($la_address_edit_hint);
    }

    ?>
    <table>
    <tr>
    <td>
    <?php

    print $la_id . ': ' . $_SESSION['id'] . '<br/>';

    // Skipped fields
    $arr_skipped_fields_edit = array(     
         'id',
         $la_id,
       );
    $form->set_skipped_fields($arr_skipped_fields_edit);
    
    if (isset($_REQUEST['edit']) and $_REQUEST['edit'] == 'all') {
        $e_a = 'a';
    }else{
        $e_a = 'e';
    }
    $form->set_form_type($e_a);
    $form->set_fields($fields_for_query);
    $form->set_tbl_and_id($tbl, $_SESSION['id']);
    $form->iterate_fields();
    ?>
        <?php
        // Hidden inputs
        if (!isset($_SESSION['id'])) { $_SESSION['id'] = '';}
        if (!isset($_REQUEST['file'])) { $_REQUEST['file'] = '';}
        if (!isset($_REQUEST['go'])) { $_REQUEST['go'] = '';}
        if (!isset($_REQUEST['value1'])) { $_REQUEST['value1'] = '';}
        $arr = array(
            'id' => $_SESSION['id'],
            'file' => $_REQUEST['file'],
            'go' => $_REQUEST['go'],
            'value1' => $_REQUEST['value1'],
        );      
        $html = new Html_Element();
        print $html->make_hidden_input_from_array($arr);
} // end form before submit

if (isset ($_REQUEST['cp'])) {
    $checked = 'checked';
}
?>
</td>
</tr>
</table>
<br/>
<?php

if ($tbl == $tbl_adr) {
    $text = $la_alter_one_field . ' surname, company, postcode oder street';
}elseif($tbl == $tbl_cal_lis) {
    $text = $la_alter_one_field . ' Pos, Gegenstand';
}

if (isset($text)) {  
    ?>
    <span style="color:gray"><?php print $text; ?></span>
    <br/>
    <?php
}


// Edit address into new record
if (    isset($_REQUEST['address_change']) 
    and $_REQUEST['address_change'] == 3
    and $_REQUEST['tbl'] == 'adr' ) 
{
    ?>
    <input type="hidden" name="address_change" value="4">
    <input type="submit" name="button" value="<?php print $la_save_in_new_record; ?>">
    <?php
    
// normal edit
}else{
    ?>
    <input type="submit" name="change_data" value="<?php print $la_save; ?>">
    <?php
}  
?>

</form>
<p>
<?php
// Link free edit
$link_free_edit = new Link_Free_Edit();
print $link_free_edit->get_link();
?>
</p>
<?php
HTML::printFoot();
?>